package de.jottyfan.csv2camt.csv;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVFormat.Builder;
import org.apache.commons.csv.CSVRecord;

/**
 * 
 * @author jotty
 * 
 */
public class CsvParser {

	protected CsvBean parse(String filename) throws IOException {
		Reader in = new FileReader(filename);
		Builder builder = CSVFormat.EXCEL.builder();
		builder.setDelimiter(";");
		Iterable<CSVRecord> records = builder.build().parse(in);
		CsvBean bean = new CsvBean();
		int counter = 0;
		for (CSVRecord record : records) {
			counter++;
			if (counter == 3) {
				bean.setKonto(record.get(0));
				bean.setKontonummer(record.get(1));
				bean.setIban(record.get(2));
				bean.setWaehrung(record.get(3));
			} else if (counter == 5) {
				bean.setZeitraum(record.get(0));
			} else if (counter == 6) {
				bean.setLetzterKontostand(record.get(4));
			} else if (counter > 8) {
				String buchungstag = record.get(0);
				if (!"Kontostand".equals(buchungstag)) {
					String wert = record.get(1);
					String umsatzart = record.get(2);
					String beguenstigter = record.get(3);
					String verwendungszweck = record.get(4);
					String iban = record.get(5);
					String bic = record.get(6);
					String kundenreferenz = record.get(7);
					String mandatsreferenz = record.get(8);
					String glaeubigerId = record.get(9);
					String fremdeGebuehren = record.get(10);
					String betrag = record.get(11);
					String abweichenderEmpfaenger = record.get(12);
					String anzahlDerAuftraege = record.get(13);
					String anzahlDerSchecks = record.get(14);
					String soll = record.get(15);
					String haben = record.get(16);
					String waehrung = record.get(17);
					bean.getList()
							.add(new CsvLine(buchungstag, wert, umsatzart, beguenstigter, verwendungszweck, iban, bic, kundenreferenz,
									mandatsreferenz, glaeubigerId, fremdeGebuehren, betrag, abweichenderEmpfaenger, anzahlDerAuftraege,
									anzahlDerSchecks, soll, haben, waehrung));
				} else {
					bean.setKontostandDatum(record.get(1));
					bean.setKontostandFinal(record.get(4));
				}
			}
		}
		return bean;
	}

	public CsvBean read(String filename) throws IOException {
		return parse(filename);
	}

}
