package de.jottyfan.csv2camt.xml;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author jotty
 * 
 */
public class XmlTag {
	private Element element; 

	public XmlTag(Document xml, String tagName) {
		this.element = xml.createElement(tagName);
	}
	
	public XmlTag(Document xml, String tagName, Element parent) {
		this.element = xml.createElement(tagName);
		parent.appendChild(element);
	}
	
	public XmlTag withAttr(String name, String value) {
		this.element.setAttribute(name, value);
		return this;
	}

	public XmlTag withText(String text) {
		this.element.setTextContent(text);
		return this;
	}
	
	public final Element get() {
		return this.element;
	}

	public static final String yyyyMMdd(String date) {
    return LocalDate.parse(date, DateTimeFormatter.ofPattern("d.M.yyyy")).format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
	}	
}
